var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
import { inject, watch, isVue2, h as h$1, defineComponent, ref, provide, onMounted, onUnmounted, onBeforeMount, getCurrentInstance, computed, reactive } from "vue-demi";
function useEvent$1({ events, emit, instance, emitted, extData }) {
  if (events instanceof Object) {
    events = Object.keys(events);
  }
  events.forEach((event) => {
    instance.addEventListener(event, (e) => {
      emit(event, __spreadProps(__spreadValues({}, e), { extData }));
      emitted == null ? void 0 : emitted(event);
    });
  });
}
const DEFAULT_CONFIG = {
  v: "4.0",
  tk: "",
  plugins: []
};
const PLUGINS_URL = {
  D3: [
    "https://cdn.bootcss.com/d3/3.5.17/d3.min.js",
    "http://lbs.tianditu.gov.cn/api/js4.0/opensource/openlibrary/D3SvgOverlay.min.js"
  ],
  CarTrack: [
    "https://cdn.bootcss.com/d3/3.5.17/d3.min.js",
    "http://lbs.tianditu.gov.cn/api/js4.0/opensource/openlibrary/D3SvgOverlay.min.js",
    "http://lbs.tianditu.gov.cn/api/js4.0/opensource/openlibrary/CarTrack.min.js"
  ],
  HeatmapOverlay: ["http://lbs.tianditu.gov.cn/api/js4.0/opensource/openlibrary/HeatmapOverlay.min.js"],
  BufferTool: [
    "https://cdn.bootcss.com/Turf.js/3.0.14/turf.js",
    "http://lbs.tianditu.gov.cn/api/js4.0/opensource/openlibrary/BufferTool.min.js"
  ],
  ImageOverLayer: ["http://lbs.tianditu.gov.cn/api/js4.0/opensource/openlibrary/ImageOverlay.min.js"]
};
let isLoading = false;
async function useApiLoader(config = {}) {
  if (isLoading) {
    return new Promise((resolve) => {
      setTimeout(() => resolve(useApiLoader(config)));
    });
  } else if (globalThis.T) {
    return;
  } else {
    isLoading = true;
    const { v, tk, plugins } = __spreadValues(__spreadValues({}, DEFAULT_CONFIG), config);
    await loadScript(`https://api.tianditu.gov.cn/api?v=${v}&tk=${tk}`);
    await Promise.all(plugins.map((name) => PLUGINS_URL[name]).flat().map((url) => loadScript(url)));
    isLoading = false;
  }
}
function loadScript(url) {
  return new Promise((resolve, reject) => {
    var _a, _b;
    const script = (_a = globalThis.document) == null ? void 0 : _a.createElement("script");
    if (!script)
      resolve();
    script.src = url;
    script.type = "text/javascript";
    script.async = true;
    script.defer = true;
    script.onload = () => resolve();
    script.onerror = (e) => resolve();
    (_b = globalThis.document) == null ? void 0 : _b.body.appendChild(script);
  });
}
function useMapRoot() {
  return new Promise((resolve) => {
    const mapRoot = inject("mapRoot");
    const mapEmitter = inject("mapEmitter");
    if (mapRoot == null ? void 0 : mapRoot.value) {
      resolve(mapRoot == null ? void 0 : mapRoot.value);
    } else {
      mapEmitter == null ? void 0 : mapEmitter.on("mapInit", resolver);
    }
    function resolver(map) {
      mapEmitter == null ? void 0 : mapEmitter.off("mapInit", resolver);
      resolve(map);
    }
  });
}
function mitt(n) {
  return { all: n = n || new Map(), on: function(t, e) {
    var i = n.get(t);
    i ? i.push(e) : n.set(t, [e]);
  }, off: function(t, e) {
    var i = n.get(t);
    i && (e ? i.splice(i.indexOf(e) >>> 0, 1) : n.set(t, []));
  }, emit: function(t, e) {
    var i = n.get(t);
    i && i.slice().map(function(n2) {
      n2(e);
    }), (i = n.get("*")) && i.slice().map(function(n2) {
      n2(t, e);
    });
  } };
}
const NATIVE_PROPS$g = {
  icon: { type: [String, Object] },
  draggable: { type: Boolean, default: false },
  title: { type: String, default: "" },
  zIndexOffset: { type: Number, default: 0 },
  opacity: { type: Number, default: 1 }
};
const EXTRA_PROPS$e = {
  position: { type: Array, default: () => [0, 0] },
  visible: { type: Boolean, default: true },
  extData: { type: void 0 }
};
const NATIVE_EVENTS$g = {
  click: () => true,
  dblclick: () => true,
  mousedown: () => true,
  mouseup: () => true,
  mouseout: () => true,
  mouseover: () => true,
  dragstart: () => true,
  drag: () => true,
  dragend: () => true,
  remove: () => true
};
const EXTRA_EVENTS$e = {
  init: (e) => e instanceof T.Marker
};
const PROPS$g = __spreadValues(__spreadValues({}, NATIVE_PROPS$g), EXTRA_PROPS$e);
const EVENTS$g = __spreadValues(__spreadValues({}, NATIVE_EVENTS$g), EXTRA_EVENTS$e);
function useInit$h(props) {
  const { draggable, title, zIndexOffset, opacity, position } = props;
  const instance = new T.Marker(toLngLat(position), {
    draggable,
    title,
    zIndexOffset,
    opacity
  });
  return instance;
}
function useWatch$g({ props, instance }) {
  watch(() => props.position, (val) => val && instance.setLngLat(toLngLat(val)));
  watch(() => props.draggable, (val) => val ? instance.enableDragging() : instance.disableDragging());
  watch(() => props.icon, (val) => val && instance.setIcon(toIcon(val)), { immediate: true });
  watch(() => props.zIndexOffset, (val) => val && instance.setZIndexOffset(val), { immediate: true });
  watch(() => props.opacity, (val) => val && instance.setOpacity(val), { immediate: true });
  watch(() => props.visible, (val) => val ? instance.show() : instance.hide(), { immediate: true });
}
const toLngLat = (lnglat) => {
  const [lng, lat] = lnglat;
  return new T.LngLat(lng, lat);
};
const toLngLats = (lnglats) => {
  return lnglats.map((lnglat) => {
    const [lng, lat] = lnglat;
    return new T.LngLat(lng, lat);
  });
};
const toBounds = (bounds) => {
  const [[lng1, lat1], [lng2, lat2]] = bounds;
  return new T.LngLatBounds(new T.LngLat(lng1, lat1), new T.LngLat(lng2, lat2));
};
const toPoint = (point) => {
  const [x, y] = point;
  return new T.Point(x, y);
};
const objectFilter = (obj) => {
  const res = {};
  Object.keys(obj).forEach((key) => {
    if (obj[key] !== void 0) {
      res[key] = obj[key];
    }
  });
  return res;
};
const toIcon = (icon) => {
  if (typeof icon === "string") {
    return new T.Icon({ iconUrl: icon });
  } else {
    const { iconUrl, iconSize, iconAnchor } = icon;
    const iconOption = {
      iconUrl,
      iconSize: iconSize && toPoint(iconSize),
      iconAnchor: iconAnchor && toPoint(iconAnchor)
    };
    return new T.Icon(objectFilter(iconOption));
  }
};
const toMarker = (option) => {
  const marker = useInit$h(option);
  option.icon && marker.setIcon(toIcon(option.icon));
  marker.extData = option.extData;
  return marker;
};
mitt();
function uuid(len, radix) {
  const chars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz".split("");
  radix = radix != null ? radix : chars.length;
  let uuid2 = [];
  if (len) {
    uuid2 = new Array(len).fill(0).map(() => {
      return chars[0 | Math.random() * radix];
    });
  } else {
    len = 36;
    uuid2 = new Array(len).fill(0).map((e, i) => {
      const r = 0 | Math.random() * 16;
      return chars[i == 19 ? r & 3 | 8 : r];
    });
    uuid2[8] = uuid2[13] = uuid2[18] = uuid2[23] = "-";
    uuid2[14] = "4";
  }
  return uuid2.join("");
}
function debounce(func, wait = 500, immediate = false) {
  let timeout;
  return function(...args) {
    const context = this;
    if (timeout)
      clearTimeout(timeout);
    if (immediate) {
      const callNow = !timeout;
      timeout = setTimeout(function() {
        timeout = void 0;
      }, wait);
      if (callNow)
        func.apply(context, args);
    } else {
      timeout = setTimeout(function() {
        func.apply(context, args);
      }, wait);
    }
  };
}
const adaptOnsV3 = (ons) => {
  if (!ons)
    return null;
  return Object.entries(ons).reduce((ret, [key, handler]) => {
    key = key.charAt(0).toUpperCase() + key.slice(1);
    key = `on${key}`;
    return __spreadProps(__spreadValues({}, ret), { [key]: handler });
  }, {});
};
const h = (type, options, chidren) => {
  if (isVue2)
    return h$1(type, options, chidren);
  const _a = options != null ? options : {}, { attrs, props, domProps, on, scopedSlots } = _a, extraOptions = __objRest(_a, ["attrs", "props", "domProps", "on", "scopedSlots"]);
  const ons = adaptOnsV3(on);
  const params = __spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues({}, extraOptions != null ? extraOptions : {}), attrs != null ? attrs : {}), props != null ? props : {}), domProps != null ? domProps : {}), ons != null ? ons : {});
  return h$1(type, params, scopedSlots || chidren);
};
const slot = (s, attrs) => {
  if (typeof s == "function")
    return s(attrs);
  return s;
};
function fixMapPropagation(map) {
  return {
    mousewheel: (e) => e.stopPropagation(),
    click: (e) => {
      e.stopPropagation();
      if (map == null ? void 0 : map.isDoubleClickZoom()) {
        map == null ? void 0 : map.disableDoubleClickZoom();
        setTimeout(() => map == null ? void 0 : map.enableDoubleClickZoom(), 300);
      }
    },
    mousemove: (e) => {
      e.stopPropagation();
      if (map == null ? void 0 : map.isDrag()) {
        map == null ? void 0 : map.disableDrag();
        setTimeout(() => map == null ? void 0 : map.enableDrag(), 300);
      }
    }
  };
}
const NATIVE_PROPS$f = {
  projection: { type: String, default: "EPSG:900913" },
  minZoom: { type: Number, default: 1 },
  maxZoom: { type: Number, default: 18 },
  center: { type: Array, default: () => [0, 0] },
  zoom: { type: Number, default: 1 }
};
const EXTRA_PROPS$d = {
  drag: { type: Boolean, default: true },
  scrollWheelZoom: { type: Boolean, default: true },
  doubleClickZoom: { type: Boolean, default: true },
  keyboard: { type: Boolean, default: true },
  inertia: { type: Boolean, default: true },
  continuousZoom: { type: Boolean, default: true },
  pinchToZoom: { type: Boolean, default: true },
  autoResize: { type: Boolean, default: true },
  maxBounds: { type: Array },
  viewport: { type: Array },
  mapStyle: { type: String },
  mid: { type: String, default: () => uuid() },
  controls: { type: Array, default: () => [] },
  loadConfig: { type: Object }
};
const NATIVE_EVENTS$f = {
  click: () => true,
  dblclick: () => true,
  contextmenu: () => true,
  mousemove: () => true,
  mouseover: () => true,
  mouseout: () => true,
  movestart: () => true,
  move: () => true,
  moveend: () => true,
  zoomstart: () => true,
  zoomend: () => true,
  addoverlay: () => true,
  removeoverlay: () => true,
  addcontrol: () => true,
  removecontrol: () => true,
  clearoverlays: () => true,
  dragstart: () => true,
  drag: () => true,
  dragend: () => true,
  layeradd: () => true,
  layerremove: () => true,
  load: () => true,
  resize: () => true,
  levels: () => true,
  touchstart: () => true,
  touchmove: () => true,
  touchend: () => true,
  longpress: () => true
};
const EXTRA_EVENTS$d = {
  init: (e) => e instanceof T.Map,
  viewchange: (e) => true
};
const PROPS$f = __spreadValues(__spreadValues({}, NATIVE_PROPS$f), EXTRA_PROPS$d);
const EVENTS$f = __spreadValues(__spreadValues({}, NATIVE_EVENTS$f), EXTRA_EVENTS$d);
function useInit$g(props, dom) {
  const { mid, projection, minZoom, maxZoom, center, zoom } = props;
  const instance = new T.Map(dom != null ? dom : mid, {
    projection,
    minZoom,
    maxZoom,
    center: toLngLat(center),
    zoom
  });
  instance.centerAndZoom(toLngLat(center), zoom);
  return instance;
}
function useWatch$f({ props, instance }) {
  watch(() => ({ center: props.center, zoom: props.zoom }), (val) => {
    if (!val.center || !val.zoom)
      return;
    instance.panTo(toLngLat(val.center), val.zoom);
  });
  watch(() => props.drag, (val) => val ? instance.enableDrag() : instance.disableDrag(), { immediate: true });
  watch(() => props.scrollWheelZoom, (val) => val ? instance.enableScrollWheelZoom() : instance.disableScrollWheelZoom(), { immediate: true });
  watch(() => props.doubleClickZoom, (val) => val ? instance.enableDoubleClickZoom() : instance.disableDoubleClickZoom(), { immediate: true });
  watch(() => props.keyboard, (val) => val ? instance.enableKeyboard() : instance.disableKeyboard(), { immediate: true });
  watch(() => props.inertia, (val) => val ? instance.enableInertia() : instance.disableInertia(), { immediate: true });
  watch(() => props.continuousZoom, (val) => val ? instance.enableContinuousZoom() : instance.disableContinuousZoom(), { immediate: true });
  watch(() => props.pinchToZoom, (val) => val ? instance.enablePinchToZoom() : instance.disablePinchToZoom(), { immediate: true });
  watch(() => props.autoResize, (val) => val ? instance.enableAutoResize() : instance.disableAutoResize(), { immediate: true });
  watch(() => props.minZoom, (val) => val && instance.setMinZoom(val));
  watch(() => props.maxZoom, (val) => val && instance.setMaxZoom(val), { immediate: true });
  watch(() => props.maxBounds, (val) => val && instance.setMaxBounds(toBounds(val)), { immediate: true });
  watch(() => props.viewport, (val) => val && instance.setViewport(val == null ? void 0 : val.map((lnglat) => toLngLat(lnglat))), { immediate: true });
  watch(() => props.mapStyle, (val) => val ? instance.setStyle(val) : instance.removeStyle(), { immediate: true });
}
function useControls(props, map, emit) {
  var _a;
  (_a = props.controls) == null ? void 0 : _a.forEach((option) => {
    if (typeof option === "string") {
      addControlByName(option);
    } else if (typeof option === "object") {
      addControlByOption(option);
    }
  });
  function addControlByName(option) {
    const controlName = option;
    if (!T.Control[controlName]) {
      setTimeout(() => addControlByName(option));
      return;
    }
    const control = new T.Control[controlName]();
    if (controlName === "OverviewMap") {
      const c = control;
      c.addEventListener("viewchange", (e) => emit("viewchange", e));
    }
    map.addControl(control);
  }
  function addControlByOption(option) {
    var _a2, _b;
    const controlName = option.name;
    if (!T.Control[controlName]) {
      setTimeout(() => addControlByOption(option));
      return;
    }
    switch (controlName) {
      case "MapType":
        {
          const mapTypes = (_a2 = option.mapTypes) == null ? void 0 : _a2.map((item) => {
            return __spreadProps(__spreadValues({}, item), {
              layer: window[item.layer]
            });
          });
          const control = new T.Control.MapType(mapTypes);
          option.position && control.setPosition(option.position);
          map.addControl(control);
        }
        break;
      case "OverviewMap":
        {
          const control = new T.Control.OverviewMap(option);
          control.addEventListener("viewchange", (e) => emit("viewchange", e));
          map.addControl(control);
        }
        break;
      case "Copyright":
        {
          const control = new T.Control.Copyright({ position: option.position || "bottomleft" });
          map.addControl(control);
          control.addCopyright(__spreadProps(__spreadValues({}, option), {
            bounds: ((_b = option.bounds) == null ? void 0 : _b.length) ? toBounds(option.bounds) : void 0
          }));
        }
        break;
      default:
        {
          const control = new T.Control[controlName](option);
          map.addControl(control);
        }
        break;
    }
  }
}
const TdtMap = defineComponent({
  name: "TdtMap",
  props: PROPS$f,
  emits: EVENTS$f,
  setup(props, { emit, slots }) {
    const tdtMap = ref();
    const mapEmitter = mitt();
    provide("mapRoot", tdtMap);
    provide("mapEmitter", mapEmitter);
    const tdtMapRef = h("div", {
      class: "tdt-map",
      style: "width:100%;height:100%",
      attrs: { id: props.mid }
    });
    onMounted(async () => {
      await useApiLoader(props.loadConfig);
      tdtMap.value = useInit$g(props, tdtMapRef.el || tdtMapRef.elm);
      useEvent$1({ events: NATIVE_EVENTS$f, emit, instance: tdtMap.value });
      useWatch$f({ props, instance: tdtMap.value });
      useControls(props, tdtMap.value, emit);
      emit("init", tdtMap.value);
      mapEmitter.emit("mapInit", tdtMap.value);
    });
    return () => {
      var _a;
      return h("div", {
        class: "tdt-map-container",
        style: "width:100%;height:100%"
      }, [tdtMapRef, (_a = slots.default) == null ? void 0 : _a.call(slots)]);
    };
  }
});
const NATIVE_PROPS$e = {
  position: { type: String, default: "topright" }
};
const OTHER_PROPS$1 = {
  offset: { type: Array },
  visible: { type: Boolean, default: true }
};
const NATIVE_EVENTS$e = {};
const OTHER_EVENTS$1 = {
  init: (e) => e instanceof T.Control
};
const PROPS$e = __spreadValues(__spreadValues({}, NATIVE_PROPS$e), OTHER_PROPS$1);
const EVENTS$e = __spreadValues(__spreadValues({}, NATIVE_EVENTS$e), OTHER_EVENTS$1);
function useInit$f(props) {
  const { position } = props;
  const instance = new T.Control({ position });
  return instance;
}
function useWatch$e({ props, instance }) {
  watch(() => props.position, (val) => val && instance.setPosition(val));
  watch(() => props.offset, (val) => val && instance.setOffset(toPoint(val)), { immediate: true });
  watch(() => props.visible, (val) => val ? instance.show() : instance.hide(), { immediate: true });
}
const TdtControl = defineComponent({
  name: "TdtControl",
  props: PROPS$e,
  emits: EVENTS$e,
  setup(props, { emit, slots }) {
    let controlRef = h("div");
    onMounted(async () => {
      onUnmounted(() => tdtComponent && (tdtMap == null ? void 0 : tdtMap.removeControl(tdtComponent)));
      const tdtMap = await useMapRoot();
      const tdtComponent = useInit$f(props);
      tdtComponent.onAdd = () => controlRef.el || controlRef.elm;
      tdtComponent.onRemove = () => {
      };
      tdtMap.addControl(tdtComponent);
      useEvent$1({ events: NATIVE_EVENTS$e, emit, instance: tdtComponent });
      useWatch$e({ props, instance: tdtComponent });
      emit("init", tdtComponent);
    });
    return () => {
      var _a;
      controlRef = h("div", { class: "tdt-control-custom" }, (_a = slots.default) == null ? void 0 : _a.call(slots));
      return controlRef;
    };
  }
});
const NATIVE_PROPS$d = {
  markTool: { type: Object, default: () => ({}) },
  polygonTool: { type: Object, default: () => ({}) },
  polylineTool: { type: Object, default: () => ({}) },
  rectangleTool: { type: Object, default: () => ({}) },
  circleTool: { type: Object, default: () => ({}) },
  paintBrushTool: { type: Object, default: () => ({}) }
};
const OTHER_PROPS = {};
const NATIVE_EVENTS$d = {
  "mark-mouseup": () => true,
  "polygon-draw": () => true,
  "polygon-addpoint": () => true,
  "polyline-draw": () => true,
  "polyline-addpoint": () => true,
  "rectangle-draw": () => true,
  "circle-draw": () => true,
  "circle-drawend": () => true
};
const OTHER_EVENTS = {
  init: (e) => {
    return e.markTool instanceof T.MarkTool && e.polygonTool instanceof T.PolygonTool && e.polylineTool instanceof T.PolylineTool && e.rectangleTool instanceof T.RectangleTool && e.circleTool instanceof T.CircleTool && e.paintBrushTool instanceof T.PaintBrushTool;
  }
};
const PROPS$d = __spreadValues(__spreadValues({}, NATIVE_PROPS$d), OTHER_PROPS);
const EVENTS$d = __spreadValues(__spreadValues({}, NATIVE_EVENTS$d), OTHER_EVENTS);
function useInit$e(props, map) {
  const { markTool, polygonTool, polylineTool, rectangleTool, circleTool, paintBrushTool } = props;
  const instances = {};
  if (markTool.icon) {
    instances.markTool = new T.MarkTool(map, {
      icon: toIcon(markTool.icon),
      follow: markTool.follow
    });
  } else {
    instances.markTool = new T.MarkTool(map, { follow: markTool.follow });
  }
  instances.polygonTool = new T.PolygonTool(map, polygonTool);
  instances.polylineTool = new T.PolylineTool(map, polylineTool);
  instances.rectangleTool = new T.RectangleTool(map, rectangleTool);
  instances.circleTool = new T.CircleTool(map, circleTool);
  instances.paintBrushTool = new T.PaintBrushTool(map, {
    keepdrawing: paintBrushTool.keepdrawing,
    style: __spreadValues({}, paintBrushTool || {})
  });
  return instances;
}
function useWatch$d({ props, instances }) {
  watch(() => {
    var _a;
    return (_a = props.markTool) == null ? void 0 : _a.icon;
  }, (val) => {
    var _a, _b;
    if (!val)
      return;
    if (typeof val === "string") {
      (_a = instances.markTool) == null ? void 0 : _a.setPointImage(val);
    } else {
      (val == null ? void 0 : val.iconUrl) && ((_b = instances.markTool) == null ? void 0 : _b.setPointImage(val == null ? void 0 : val.iconUrl));
    }
  });
}
function useEvent({ emit, instances }) {
  var _a, _b, _c, _d, _e, _f, _g, _h;
  (_a = instances.markTool) == null ? void 0 : _a.addEventListener("mouseup", (e) => emit("mark-mouseup", e));
  (_b = instances.polygonTool) == null ? void 0 : _b.addEventListener("draw", (e) => emit("polygon-draw", e));
  (_c = instances.polygonTool) == null ? void 0 : _c.addEventListener("addpoint", (e) => emit("polygon-draw", e));
  (_d = instances.polylineTool) == null ? void 0 : _d.addEventListener("draw", (e) => emit("polyline-draw", e));
  (_e = instances.polylineTool) == null ? void 0 : _e.addEventListener("addpoint", (e) => emit("polyline-addpoint", e));
  (_f = instances.rectangleTool) == null ? void 0 : _f.addEventListener("draw", (e) => emit("rectangle-draw", e));
  (_g = instances.circleTool) == null ? void 0 : _g.addEventListener("draw", (e) => emit("circle-draw", e));
  (_h = instances.circleTool) == null ? void 0 : _h.addEventListener("drawend", (e) => emit("circle-drawend", e));
}
const TdtMousetool = defineComponent({
  name: "TdtMousetool",
  props: PROPS$d,
  emits: EVENTS$d,
  setup(props, { emit, expose }) {
    onBeforeMount(async () => {
      var _a;
      onUnmounted(() => clearAll());
      expose == null ? void 0 : expose({ open, close, clear, clearAll });
      if (isVue2) {
        const vm = (_a = getCurrentInstance()) == null ? void 0 : _a.proxy;
        vm.open = open;
        vm.close = close;
        vm.clear = clear;
        vm.clearAll = clearAll;
      }
      const tdtMap = await useMapRoot();
      const tdtComponent = useInit$e(props, tdtMap);
      useEvent({ emit, instances: tdtComponent });
      useWatch$d({ props, instances: tdtComponent });
      emit("init", tdtComponent);
      function open(toolName) {
        var _a2;
        (_a2 = tdtComponent[toolName]) == null ? void 0 : _a2.open();
      }
      function close(toolName) {
        var _a2;
        (_a2 = tdtComponent[toolName]) == null ? void 0 : _a2.close();
      }
      function clear(toolName) {
        var _a2;
        try {
          (_a2 = tdtComponent[toolName]) == null ? void 0 : _a2.clear();
        } catch (e) {
          console.error(e);
        }
      }
      function clearAll() {
        Object.keys(tdtComponent).forEach((toolName) => {
          close(toolName);
          clear(toolName);
        });
      }
    });
    return () => {
    };
  }
});
const TdtMarker = defineComponent({
  name: "TdtMarker",
  props: PROPS$g,
  emits: EVENTS$g,
  setup(props, { emit }) {
    onBeforeMount(async () => {
      onUnmounted(() => tdtComponent && (tdtMap == null ? void 0 : tdtMap.removeOverLay(tdtComponent)));
      const tdtMap = await useMapRoot();
      const tdtComponent = useInit$h(props);
      tdtMap.addOverLay(tdtComponent);
      useEvent$1({ events: NATIVE_EVENTS$g, emit, instance: tdtComponent, extData: props.extData });
      useWatch$g({ props, instance: tdtComponent });
      emit("init", tdtComponent);
    });
    return () => {
    };
  }
});
const NATIVE_PROPS$c = {
  text: { type: String, default: "" },
  offset: { type: Array, default: () => [0, 0] },
  position: { type: Array, default: () => [0, 0] }
};
const EXTRA_PROPS$c = {
  title: { type: String },
  zIndex: { type: Number },
  fontSize: { type: Number },
  fontColor: { type: String },
  backgroundColor: { type: String },
  borderLine: { type: Number },
  borderColor: { type: String },
  opacity: { type: Number },
  visible: { type: Boolean, default: true },
  extData: { type: void 0 }
};
const NATIVE_EVENTS$c = {
  click: () => true,
  dblclick: () => true,
  mousedown: () => true,
  mouseup: () => true,
  mouseout: () => true,
  mouseover: () => true,
  remove: () => true
};
const EXTRA_EVENTS$c = {
  init: (e) => e instanceof T.Label
};
const PROPS$c = __spreadValues(__spreadValues({}, NATIVE_PROPS$c), EXTRA_PROPS$c);
const EVENTS$c = __spreadValues(__spreadValues({}, NATIVE_EVENTS$c), EXTRA_EVENTS$c);
function useInit$d(props) {
  const { position, offset, text } = props;
  const instance = new T.Label({
    position: toLngLat(position),
    offset: toPoint(offset),
    text
  });
  return instance;
}
function useWatch$c({ props, instance }) {
  watch(() => props.position, (val) => val && instance.setLngLat(toLngLat(val)));
  watch(() => props.text, (val) => val && instance.setLabel(val));
  watch(() => props.offset, (val) => val && instance.setOffset(toPoint(val)));
  watch(() => props.title, (val) => val && instance.setTitle(val), { immediate: true });
  watch(() => props.zIndex, (val) => val && instance.setZIndex(val), { immediate: true });
  watch(() => props.fontSize, (val) => val && instance.setFontSize(val), { immediate: true });
  watch(() => props.fontColor, (val) => val && instance.setFontColor(val), { immediate: true });
  watch(() => props.backgroundColor, (val) => val && instance.setBackgroundColor(val), { immediate: true });
  watch(() => props.borderLine, (val) => val && instance.setBorderLine(val), { immediate: true });
  watch(() => props.borderColor, (val) => val && instance.setBorderColor(val), { immediate: true });
  watch(() => props.opacity, (val) => val && instance.setOpacity(val), { immediate: true });
  watch(() => props.visible, (val) => val ? instance.show() : instance.hide(), { immediate: true });
}
const TdtLabel = defineComponent({
  name: "TdtLabel",
  props: PROPS$c,
  emits: EVENTS$c,
  setup(props, { emit }) {
    onBeforeMount(async () => {
      onUnmounted(() => tdtComponent && (tdtMap == null ? void 0 : tdtMap.removeOverLay(tdtComponent)));
      const tdtMap = await useMapRoot();
      const tdtComponent = useInit$d(props);
      tdtMap.addOverLay(tdtComponent);
      useEvent$1({ events: NATIVE_EVENTS$c, emit, instance: tdtComponent, extData: props.extData });
      useWatch$c({ props, instance: tdtComponent });
      emit("init", tdtComponent);
    });
    return () => {
    };
  }
});
const NATIVE_PROPS$b = {
  color: { type: String, default: "#0000ff" },
  weight: { type: Number, default: 3 },
  opacity: { type: Number, default: 0.5 },
  lineStyle: { type: String, default: "solid" }
};
const EXTRA_PROPS$b = {
  edit: { type: Boolean, default: false },
  path: { type: Array, default: () => [] },
  visible: { type: Boolean, default: true },
  extData: { type: void 0 }
};
const NATIVE_EVENTS$b = {
  click: () => true,
  dblclick: () => true,
  mousedown: () => true,
  mouseup: () => true,
  mouseout: () => true,
  mouseover: () => true,
  remove: () => true
};
const EXTRA_EVENTS$b = {
  init: (e) => e instanceof T.Polyline
};
const PROPS$b = __spreadValues(__spreadValues({}, NATIVE_PROPS$b), EXTRA_PROPS$b);
const EVENTS$b = __spreadValues(__spreadValues({}, NATIVE_EVENTS$b), EXTRA_EVENTS$b);
function useInit$c(props) {
  const { path, color, weight, opacity, lineStyle } = props;
  const instance = new T.Polyline(toLngLats(path), {
    color,
    weight,
    opacity,
    lineStyle
  });
  return instance;
}
function useWatch$b({ props, instance }) {
  watch(() => props.path, (val) => val && instance.setLngLats(toLngLats(val)));
  watch(() => props.color, (val) => val && instance.setColor(val));
  watch(() => props.opacity, (val) => val && instance.setOpacity(val));
  watch(() => props.weight, (val) => val && instance.setWeight(val));
  watch(() => props.lineStyle, (val) => val && instance.setLineStyle(val));
  watch(() => props.edit, (val) => val ? instance.enableEdit() : instance.disableEdit(), { immediate: true });
  watch(() => props.visible, (val) => val ? instance.show() : instance.hide(), { immediate: true });
}
const TdtPolyline = defineComponent({
  name: "TdtPolyline",
  props: PROPS$b,
  emits: EVENTS$b,
  setup(props, { emit }) {
    onBeforeMount(async () => {
      onUnmounted(() => tdtComponent && (tdtMap == null ? void 0 : tdtMap.removeOverLay(tdtComponent)));
      const tdtMap = await useMapRoot();
      const tdtComponent = useInit$c(props);
      tdtMap.addOverLay(tdtComponent);
      useEvent$1({ events: NATIVE_EVENTS$b, emit, instance: tdtComponent, extData: props.extData });
      useWatch$b({ props, instance: tdtComponent });
      emit("init", tdtComponent);
    });
    return () => {
    };
  }
});
const NATIVE_PROPS$a = {
  color: { type: String, default: "#0000ff" },
  weight: { type: Number, default: 3 },
  opacity: { type: Number, default: 0.5 },
  lineStyle: { type: String, default: "solid" },
  fillColor: { type: String, default: "#0000ff" },
  fillOpacity: { type: Number, default: 0.2 }
};
const EXTRA_PROPS$a = {
  edit: { type: Boolean, default: false },
  path: { type: Array, default: () => [] },
  visible: { type: Boolean, default: true },
  extData: { type: void 0 }
};
const NATIVE_EVENTS$a = {
  click: () => true,
  dblclick: () => true,
  mousedown: () => true,
  mouseup: () => true,
  mouseout: () => true,
  mouseover: () => true,
  remove: () => true
};
const EXTRA_EVENTS$a = {
  init: (e) => e instanceof T.Polygon
};
const PROPS$a = __spreadValues(__spreadValues({}, NATIVE_PROPS$a), EXTRA_PROPS$a);
const EVENTS$a = __spreadValues(__spreadValues({}, NATIVE_EVENTS$a), EXTRA_EVENTS$a);
function useInit$b(props) {
  const { path, color, weight, opacity, lineStyle, fillColor, fillOpacity } = props;
  const instance = new T.Polygon(toLngLats(path), {
    color,
    weight,
    opacity,
    lineStyle,
    fillColor,
    fillOpacity
  });
  return instance;
}
function useWatch$a({ props, instance }) {
  watch(() => props.path, (val) => val && instance.setLngLats(toLngLats(val)));
  watch(() => props.color, (val) => val && instance.setColor(val));
  watch(() => props.opacity, (val) => val && instance.setOpacity(val));
  watch(() => props.weight, (val) => val && instance.setWeight(val));
  watch(() => props.lineStyle, (val) => val && instance.setLineStyle(val));
  watch(() => props.fillColor, (val) => val && instance.setFillColor(val));
  watch(() => props.fillOpacity, (val) => val && instance.setFillOpacity(val));
  watch(() => props.edit, (val) => val ? instance.enableEdit() : instance.disableEdit(), { immediate: true });
  watch(() => props.visible, (val) => val ? instance.show() : instance.hide(), { immediate: true });
}
const TdtPolygon = defineComponent({
  name: "TdtPolygon",
  props: PROPS$a,
  emits: EVENTS$a,
  setup(props, { emit }) {
    onBeforeMount(async () => {
      onUnmounted(() => tdtComponent && (tdtMap == null ? void 0 : tdtMap.removeOverLay(tdtComponent)));
      const tdtMap = await useMapRoot();
      const tdtComponent = useInit$b(props);
      tdtMap.addOverLay(tdtComponent);
      useEvent$1({ events: NATIVE_EVENTS$a, emit, instance: tdtComponent, extData: props.extData });
      useWatch$a({ props, instance: tdtComponent });
      emit("init", tdtComponent);
    });
    return () => {
    };
  }
});
const NATIVE_PROPS$9 = {
  color: { type: String, default: "#0000ff" },
  weight: { type: Number, default: 3 },
  opacity: { type: Number, default: 0.5 },
  lineStyle: { type: String, default: "solid" },
  fillColor: { type: String, default: "#0000ff" },
  fillOpacity: { type: Number, default: 0.2 }
};
const EXTRA_PROPS$9 = {
  edit: { type: Boolean, default: false },
  bounds: { type: Array, default: () => [] },
  visible: { type: Boolean, default: true },
  extData: { type: void 0 }
};
const NATIVE_EVENTS$9 = {
  click: () => true,
  dblclick: () => true,
  mousedown: () => true,
  mouseup: () => true,
  mouseout: () => true,
  mouseover: () => true,
  remove: () => true
};
const EXTRA_EVENTS$9 = {
  init: (e) => e instanceof T.Rectangle
};
const PROPS$9 = __spreadValues(__spreadValues({}, NATIVE_PROPS$9), EXTRA_PROPS$9);
const EVENTS$9 = __spreadValues(__spreadValues({}, NATIVE_EVENTS$9), EXTRA_EVENTS$9);
function useInit$a(props) {
  const { bounds, color, weight, opacity, lineStyle, fillColor, fillOpacity } = props;
  const instance = new T.Rectangle(toBounds(bounds), {
    color,
    weight,
    opacity,
    lineStyle,
    fillColor,
    fillOpacity
  });
  return instance;
}
function useWatch$9({ props, instance }) {
  watch(() => props.bounds, (val) => val && instance.setBounds(toBounds(val)));
  watch(() => props.color, (val) => val && instance.setColor(val));
  watch(() => props.opacity, (val) => val && instance.setOpacity(val));
  watch(() => props.weight, (val) => val && instance.setWeight(val));
  watch(() => props.lineStyle, (val) => val && instance.setLineStyle(val));
  watch(() => props.fillColor, (val) => val && instance.setFillColor(val));
  watch(() => props.fillOpacity, (val) => val && instance.setFillOpacity(val));
  watch(() => props.edit, (val) => val ? instance.enableEdit() : instance.disableEdit(), { immediate: true });
  watch(() => props.visible, (val) => val ? instance.show() : instance.hide(), { immediate: true });
}
const TdtRectangle = defineComponent({
  name: "TdtRectangle",
  props: PROPS$9,
  emits: EVENTS$9,
  setup(props, { emit }) {
    onBeforeMount(async () => {
      onUnmounted(() => tdtComponent && (tdtMap == null ? void 0 : tdtMap.removeOverLay(tdtComponent)));
      const tdtMap = await useMapRoot();
      const tdtComponent = useInit$a(props);
      tdtMap.addOverLay(tdtComponent);
      useEvent$1({ events: NATIVE_EVENTS$9, emit, instance: tdtComponent, extData: props.extData });
      useWatch$9({ props, instance: tdtComponent });
      emit("init", tdtComponent);
    });
    return () => {
    };
  }
});
const NATIVE_PROPS$8 = {
  color: { type: String, default: "#0000ff" },
  weight: { type: Number, default: 3 },
  opacity: { type: Number, default: 0.5 },
  lineStyle: { type: String, default: "solid" },
  fillColor: { type: String, default: "#0000ff" },
  fillOpacity: { type: Number, default: 0.2 }
};
const EXTRA_PROPS$8 = {
  edit: { type: Boolean, default: false },
  center: { type: Array, default: () => [0, 0] },
  radius: { type: Number, default: 0 },
  visible: { type: Boolean, default: true },
  extData: { type: void 0 }
};
const NATIVE_EVENTS$8 = {
  click: () => true,
  dblclick: () => true,
  mousedown: () => true,
  mouseup: () => true,
  mouseout: () => true,
  mouseover: () => true,
  remove: () => true
};
const EXTRA_EVENTS$8 = {
  init: (e) => e instanceof T.Circle
};
const PROPS$8 = __spreadValues(__spreadValues({}, NATIVE_PROPS$8), EXTRA_PROPS$8);
const EVENTS$8 = __spreadValues(__spreadValues({}, NATIVE_EVENTS$8), EXTRA_EVENTS$8);
function useInit$9(props) {
  const { center, radius, color, weight, opacity, lineStyle, fillColor, fillOpacity } = props;
  const instance = new T.Circle(toLngLat(center), radius, {
    color,
    weight,
    opacity,
    lineStyle,
    fillColor,
    fillOpacity
  });
  return instance;
}
function useWatch$8({ props, instance }) {
  watch(() => props.center, (val) => val && instance.setCenter(toLngLat(val)));
  watch(() => props.radius, (val) => val && instance.setRadius(val));
  watch(() => props.color, (val) => val && instance.setColor(val));
  watch(() => props.opacity, (val) => val && instance.setOpacity(val));
  watch(() => props.weight, (val) => val && instance.setWeight(val));
  watch(() => props.lineStyle, (val) => val && instance.setLineStyle(val));
  watch(() => props.fillColor, (val) => val && instance.setFillColor(val));
  watch(() => props.fillOpacity, (val) => val && instance.setFillOpacity(val));
  watch(() => props.edit, (val) => val ? instance.enableEdit() : instance.disableEdit(), { immediate: true });
  watch(() => props.visible, (val) => val ? instance.show() : instance.hide(), { immediate: true });
}
const TdtCircle = defineComponent({
  name: "TdtCircle",
  props: PROPS$8,
  emits: EVENTS$8,
  setup(props, { emit }) {
    onBeforeMount(async () => {
      onUnmounted(() => tdtComponent && (tdtMap == null ? void 0 : tdtMap.removeOverLay(tdtComponent)));
      const tdtMap = await useMapRoot();
      const tdtComponent = useInit$9(props);
      tdtMap.addOverLay(tdtComponent);
      useEvent$1({ events: NATIVE_EVENTS$8, emit, instance: tdtComponent, extData: props.extData });
      useWatch$8({ props, instance: tdtComponent });
      emit("init", tdtComponent);
    });
    return () => {
    };
  }
});
const NATIVE_PROPS$7 = {
  minWidth: { type: Number, default: 50 },
  maxWidth: { type: Number, default: 300 },
  maxHeight: { type: Number, default: null },
  autoPan: { type: Boolean, default: false },
  closeButton: { type: Boolean, default: true },
  offset: { type: Array, default: () => [0, 7] },
  autoPanPadding: { type: Array, default: () => [5, 5] },
  closeOnClick: { type: Boolean, default: false }
};
const EXTRA_PROPS$7 = {
  content: { type: [String, Object, HTMLElement], default: "" },
  target: { type: [Object, Array], default: null }
};
const NATIVE_EVENTS$7 = {
  close: () => true,
  open: () => true,
  clickclose: () => true
};
const EXTRA_EVENTS$7 = {
  init: (e) => e instanceof T.InfoWindow,
  "update:target": (e) => true
};
const PROPS$7 = __spreadValues(__spreadValues({}, NATIVE_PROPS$7), EXTRA_PROPS$7);
const EVENTS$7 = __spreadValues(__spreadValues({}, NATIVE_EVENTS$7), EXTRA_EVENTS$7);
function useInit$8(props, contentRef) {
  const { minWidth, maxWidth, maxHeight, autoPan, closeButton, offset, autoPanPadding, closeOnClick, content } = props;
  const instance = new T.InfoWindow(contentRef || content, {
    minWidth,
    maxWidth,
    maxHeight,
    autoPan,
    closeButton,
    offset: toPoint(offset),
    autoPanPadding: toPoint(autoPanPadding),
    closeOnClick
  });
  return instance;
}
function useWatch$7({ props, instance, map }) {
  watch(() => props.offset, (val) => val && instance.setOffset(toPoint(val)));
  watch(() => props.content, (val) => val && instance.setContent(val));
  watch(() => props.target, (val) => {
    if (val instanceof Array) {
      map.openInfoWindow(instance, toLngLat(val));
    } else {
      val ? val.openInfoWindow(instance) : instance.closeInfoWindow();
    }
  }, { immediate: true });
}
const TdtInfowindow = defineComponent({
  name: "TdtInfowindow",
  props: PROPS$7,
  emits: EVENTS$7,
  setup(props, { emit, slots }) {
    const contentRef = computed(() => {
      var _a;
      return h("div", {
        class: "tdt-infowindow-custom",
        style: {
          minWidth: props.minWidth,
          maxWidth: props.maxWidth,
          maxHeight: props.maxHeight,
          display: slots.default && props.target ? "block" : "none"
        }
      }, (_a = slots.default) == null ? void 0 : _a.call(slots));
    });
    onMounted(async () => {
      onUnmounted(() => tdtMap == null ? void 0 : tdtMap.closeInfoWindow());
      const content = slots.default ? contentRef.value.el || contentRef.value.elm : void 0;
      const tdtMap = await useMapRoot();
      const tdtComponent = useInit$8(props, content);
      useEvent$1({ events: NATIVE_EVENTS$7, emit, instance: tdtComponent, emitted });
      useWatch$7({ props, instance: tdtComponent, map: tdtMap });
      emit("init", tdtComponent);
    });
    function emitted(event) {
      event === "close" && emit("update:target", null);
    }
    return () => contentRef.value;
  }
});
const NATIVE_PROPS$6 = {
  ShapeType: { type: String, default: "CIRCLE" },
  SizeType: { type: String, default: "TINY" },
  color: { type: String, default: "#fa937e" }
};
const EXTRA_PROPS$6 = {
  lnglats: { type: Array, default: () => [] }
};
const NATIVE_EVENTS$6 = {
  click: () => true,
  mouseover: () => true,
  mouseout: () => true
};
const EXTRA_EVENTS$6 = {
  init: (e) => e instanceof T.CloudMarkerCollection
};
const PROPS$6 = __spreadValues(__spreadValues({}, NATIVE_PROPS$6), EXTRA_PROPS$6);
const EVENTS$6 = __spreadValues(__spreadValues({}, NATIVE_EVENTS$6), EXTRA_EVENTS$6);
function useInit$7(props) {
  const { ShapeType, SizeType, color, lnglats } = props;
  const instance = new T.CloudMarkerCollection(toLngLats(lnglats), {
    ShapeType,
    SizeType,
    color
  });
  return instance;
}
function useWatch$6({ props, instance }) {
  watch(() => props.lnglats, (val) => val && instance.setLnglats(toLngLats(val)));
  watch(() => props, (val) => instance.setStyles(val));
}
const TdtCloudMarkerCollection = defineComponent({
  name: "TdtCloudMarkerCollection",
  props: PROPS$6,
  emits: EVENTS$6,
  setup(props, { emit }) {
    onBeforeMount(async () => {
      onUnmounted(() => {
        tdtComponent == null ? void 0 : tdtComponent.clear();
        tdtComponent && (tdtMap == null ? void 0 : tdtMap.removeOverLay(tdtComponent));
      });
      const tdtMap = await useMapRoot();
      const tdtComponent = useInit$7(props);
      tdtMap.addOverLay(tdtComponent);
      useEvent$1({ events: NATIVE_EVENTS$6, emit, instance: tdtComponent });
      useWatch$6({ props, instance: tdtComponent });
      emit("init", tdtComponent);
    });
    return () => {
    };
  }
});
const NATIVE_PROPS$5 = {
  markers: { type: Array },
  girdSize: { type: Number },
  maxZoom: { type: Number },
  styles: { type: Array }
};
const EXTRA_PROPS$5 = {};
const NATIVE_EVENTS$5 = {
  click: () => true,
  clusterclick: () => true,
  dblclick: () => true,
  mousedown: () => true,
  mouseup: () => true,
  mouseout: () => true,
  mouseover: () => true,
  dragstart: () => true,
  drag: () => true,
  dragend: () => true,
  remove: () => true
};
const EXTRA_EVENTS$5 = {
  init: (e) => e instanceof T.MarkerClusterer
};
const PROPS$5 = __spreadValues(__spreadValues({}, NATIVE_PROPS$5), EXTRA_PROPS$5);
const EVENTS$5 = __spreadValues(__spreadValues({}, NATIVE_EVENTS$5), EXTRA_EVENTS$5);
function useInit$6(props, map) {
  const { markers, girdSize, maxZoom } = props;
  const marker = markers == null ? void 0 : markers.map((item) => toMarker(item));
  const instance = new T.MarkerClusterer(map, {
    markers: marker,
    girdSize,
    maxZoom
  });
  return instance;
}
function useWatch$5({ props, instance }) {
  watch(() => props.girdSize, (val) => val && instance.setGridSize(val));
  watch(() => props.maxZoom, (val) => val && instance.setMaxZoom(val));
  watch(() => props.markers, (val) => {
    instance.clearMarkers();
    (val == null ? void 0 : val.length) && instance.addMarkers(val.map(toMarker));
  });
  watch(() => props.styles, (val) => {
    var _a;
    const styles = (_a = val == null ? void 0 : val.map((item) => {
      return __spreadProps(__spreadValues({}, item), {
        offset: item.offset && toPoint(item.offset)
      });
    })) != null ? _a : [];
    instance.setStyles(styles);
  }, { immediate: true });
}
const TdtMarkerClusterer = defineComponent({
  name: "TdtMarkerClusterer",
  props: PROPS$5,
  emits: EVENTS$5,
  setup(props, { emit }) {
    onBeforeMount(async () => {
      onUnmounted(() => tdtComponent == null ? void 0 : tdtComponent.clearMarkers());
      const tdtMap = await useMapRoot();
      const tdtComponent = useInit$6(props, tdtMap);
      useEvent$1({ events: NATIVE_EVENTS$5, emit, instance: tdtComponent });
      useWatch$5({ props, instance: tdtComponent });
      emit("init", tdtComponent);
    });
    return () => {
    };
  }
});
const NATIVE_PROPS$4 = {
  minZoom: { type: Number },
  maxZoom: { type: Number },
  errorTileUrl: { type: String },
  opacity: { type: Number },
  zIndex: { type: Number },
  bounds: { type: Array, default: () => [] },
  url: { type: String, default: "" }
};
const EXTRA_PROPS$4 = {};
const NATIVE_EVENTS$4 = {
  loading: () => true,
  load: () => true,
  tileloadstart: () => true,
  tileload: () => true,
  tileunload: () => true,
  tileerror: () => true
};
const EXTRA_EVENTS$4 = {
  init: (e) => e instanceof T.TileLayer
};
const PROPS$4 = __spreadValues(__spreadValues({}, NATIVE_PROPS$4), EXTRA_PROPS$4);
const EVENTS$4 = __spreadValues(__spreadValues({}, NATIVE_EVENTS$4), EXTRA_EVENTS$4);
function useInit$5(props, attrs) {
  const { url, minZoom, maxZoom, errorTileUrl, opacity, zIndex, bounds } = props;
  const instance = new T.TileLayer(url, __spreadValues({
    minZoom,
    maxZoom,
    errorTileUrl,
    opacity,
    zIndex,
    bounds: bounds.length ? toBounds(bounds) : void 0
  }, attrs));
  return instance;
}
function useWatch$4({ props, instance }) {
  watch(() => props.opacity, (val) => val && instance.setOpacity(val));
  watch(() => props.zIndex, (val) => val && instance.setZIndex(val));
  watch(() => props.url, (val) => val && instance.setUrl(val));
}
const TdtTilelayer = defineComponent({
  name: "TdtTilelayer",
  props: PROPS$4,
  emits: EVENTS$4,
  setup(props, { emit, attrs }) {
    onBeforeMount(async () => {
      onUnmounted(() => tdtComponent && (tdtMap == null ? void 0 : tdtMap.removeLayer(tdtComponent)));
      const tdtMap = await useMapRoot();
      const tdtComponent = useInit$5(props, attrs);
      tdtMap.addLayer(tdtComponent);
      useEvent$1({ events: NATIVE_EVENTS$4, emit, instance: tdtComponent });
      useWatch$4({ props, instance: tdtComponent });
      emit("init", tdtComponent);
    });
    return () => {
    };
  }
});
const NATIVE_PROPS$3 = {
  minZoom: { type: Number },
  maxZoom: { type: Number },
  errorTileUrl: { type: String },
  opacity: { type: Number },
  zIndex: { type: Number },
  bounds: { type: Array, default: () => [] },
  url: { type: String, default: "" }
};
const EXTRA_PROPS$3 = {};
const NATIVE_EVENTS$3 = {
  loading: () => true,
  load: () => true,
  tileloadstart: () => true,
  tileload: () => true,
  tileunload: () => true,
  tileerror: () => true
};
const EXTRA_EVENTS$3 = {
  init: (e) => e instanceof T.TileLayer.TDT
};
const PROPS$3 = __spreadValues(__spreadValues({}, NATIVE_PROPS$3), EXTRA_PROPS$3);
const EVENTS$3 = __spreadValues(__spreadValues({}, NATIVE_EVENTS$3), EXTRA_EVENTS$3);
function useInit$4(props, attrs) {
  const { url, minZoom, maxZoom, errorTileUrl, opacity, zIndex, bounds } = props;
  const instance = new T.TileLayer.TDT(url, __spreadValues({
    minZoom,
    maxZoom,
    errorTileUrl,
    opacity,
    zIndex,
    bounds: bounds.length ? toBounds(bounds) : void 0
  }, attrs));
  return instance;
}
function useWatch$3({ props, instance }) {
  watch(() => props.opacity, (val) => val && instance.setOpacity(val));
  watch(() => props.zIndex, (val) => val && instance.setZIndex(val));
  watch(() => props.url, (val) => val && instance.setUrl(val));
}
const TdtTilelayerTdt = defineComponent({
  name: "TdtTilelayerTdt",
  props: PROPS$3,
  emits: EVENTS$3,
  setup(props, { emit, attrs }) {
    onBeforeMount(async () => {
      onUnmounted(() => tdtComponent && (tdtMap == null ? void 0 : tdtMap.removeLayer(tdtComponent)));
      const tdtMap = await useMapRoot();
      const tdtComponent = useInit$4(props, attrs);
      tdtMap.addLayer(tdtComponent);
      useEvent$1({ events: NATIVE_EVENTS$3, emit, instance: tdtComponent });
      useWatch$3({ props, instance: tdtComponent });
      emit("init", tdtComponent);
    });
    return () => {
    };
  }
});
const NATIVE_PROPS$2 = {
  layers: { type: String },
  styles: { type: String },
  format: { type: String },
  transparent: { type: Boolean },
  version: { type: String },
  srs: { type: String },
  url: { type: String, default: "" }
};
const EXTRA_PROPS$2 = {
  opacity: { type: Number },
  zIndex: { type: Number }
};
const NATIVE_EVENTS$2 = {
  loading: () => true,
  load: () => true,
  tileloadstart: () => true,
  tileload: () => true,
  tileunload: () => true,
  tileerror: () => true
};
const EXTRA_EVENTS$2 = {
  init: (e) => e instanceof T.TileLayer.WMS
};
const PROPS$2 = __spreadValues(__spreadValues({}, NATIVE_PROPS$2), EXTRA_PROPS$2);
const EVENTS$2 = __spreadValues(__spreadValues({}, NATIVE_EVENTS$2), EXTRA_EVENTS$2);
function useInit$3(props, attrs) {
  const { url, layers, styles, format, transparent, version, srs } = props;
  const instance = new T.TileLayer.WMS(url, __spreadValues({
    layers,
    styles,
    format,
    transparent,
    version,
    srs
  }, attrs));
  return instance;
}
function useWatch$2({ props, instance }) {
  watch(() => props.opacity, (val) => val && instance.setOpacity(val), { immediate: true });
  watch(() => props.zIndex, (val) => val && instance.setZIndex(val), { immediate: true });
  watch(() => props.url, (val) => val && instance.setUrl(val));
}
const TdtTilelayerWms = defineComponent({
  name: "TdtTilelayerWms",
  props: PROPS$2,
  emits: EVENTS$2,
  setup(props, { emit, attrs }) {
    onBeforeMount(async () => {
      onUnmounted(() => tdtComponent && (tdtMap == null ? void 0 : tdtMap.removeLayer(tdtComponent)));
      const tdtMap = await useMapRoot();
      const tdtComponent = useInit$3(props, attrs);
      tdtMap.addLayer(tdtComponent);
      useEvent$1({ events: NATIVE_EVENTS$2, emit, instance: tdtComponent });
      useWatch$2({ props, instance: tdtComponent });
      emit("init", tdtComponent);
    });
    return () => {
    };
  }
});
const NATIVE_PROPS$1 = {
  tileSize: { type: Number, default: 256 },
  minZoom: { type: Number, default: 0 },
  maxZoom: { type: Number, default: 18 },
  opacity: { type: Number, default: 1 },
  outlineSize: {
    type: Object,
    default: () => ({ width: 1, style: "solid", color: "#999" })
  },
  textSize: {
    type: Object,
    default: () => ({ display: false, fontSize: "14", fontWeight: true, color: "black" })
  }
};
const EXTRA_PROPS$1 = {
  zIndex: { type: Number }
};
const NATIVE_EVENTS$1 = {
  loading: () => true,
  load: () => true
};
const EXTRA_EVENTS$1 = {
  init: (e) => e instanceof T.GridlineLayer
};
const PROPS$1 = __spreadValues(__spreadValues({}, NATIVE_PROPS$1), EXTRA_PROPS$1);
const EVENTS$1 = __spreadValues(__spreadValues({}, NATIVE_EVENTS$1), EXTRA_EVENTS$1);
function useInit$2(props) {
  const { tileSize, minZoom, maxZoom, opacity, outlineSize, textSize } = props;
  const instance = new T.GridlineLayer({
    tileSize,
    minZoom,
    maxZoom,
    opacity,
    outlineSize,
    textSize
  });
  return instance;
}
function useWatch$1({ props, instance }) {
  watch(() => props.opacity, (val) => val && instance.setOpacity(val));
  watch(() => props.zIndex, (val) => val && instance.setZIndex(val));
}
const TdtGridlineLayer = defineComponent({
  name: "TdtGridlineLayer",
  props: PROPS$1,
  emits: EVENTS$1,
  setup(props, { emit }) {
    onBeforeMount(async () => {
      onUnmounted(() => tdtComponent && (tdtMap == null ? void 0 : tdtMap.removeLayer(tdtComponent)));
      const tdtMap = await useMapRoot();
      const tdtComponent = useInit$2(props);
      tdtMap.addLayer(tdtComponent);
      useEvent$1({ events: NATIVE_EVENTS$1, emit, instance: tdtComponent });
      useWatch$1({ props, instance: tdtComponent });
      emit("init", tdtComponent);
    });
    return () => {
    };
  }
});
function useMethods$1(state, emit) {
  function onSearch(type = state.queryType, keyword = state.keyword, gbCode = 0) {
    var _a, _b, _c;
    state.queryType = type;
    state.keyword = keyword;
    state.current = 1;
    (_a = state.localSearch) == null ? void 0 : _a.setSpecifyAdminCode(gbCode);
    if (state.keyword) {
      (_b = state.localSearch) == null ? void 0 : _b.search(state.keyword, state.queryType);
    } else {
      (_c = state.localSearch) == null ? void 0 : _c.clearResults();
      state.target = null;
      state.pois = false;
      state.statistics = false;
      state.area = false;
      state.suggests = false;
      state.prompt = false;
      state.lineData = false;
    }
  }
  function onSearchComplete(result) {
    state.target = null;
    state.pois = result.pois;
    state.statistics = result.statistics;
    state.area = result.area;
    state.suggests = result.suggests;
    state.prompt = result.prompt;
    state.lineData = result.lineData;
    state.total = Number(result.count);
    emit("search-complete", result);
  }
  function onPoiClick(poi) {
    var _a;
    const position = poi.lonlat.split(" ").map(Number);
    (_a = state.tdtMap) == null ? void 0 : _a.panTo(toLngLat(position));
    state.target = position;
    state.content = `
      <strong>${poi.name}</strong>
      <div>\u5730\u5740\uFF1A${poi.address}</div>
      <div>\u5750\u6807\uFF1A${poi.lonlat}</div>
      `;
    emit("poi-click", poi);
  }
  function onSuggestClick(suggest) {
    onSearch(1, suggest.name, Number(suggest.gbCode));
    emit("suggest-click", suggest);
  }
  function onPageChange(page) {
    var _a;
    state.current = page.current || 1;
    (_a = state.localSearch) == null ? void 0 : _a.gotoPage(state.current);
  }
  return {
    onSearch: debounce(onSearch, 100),
    onSearchComplete,
    onPoiClick,
    onSuggestClick,
    onPageChange
  };
}
function useState$1() {
  const searchLocalState = {
    tdtMap: null,
    localSearch: null,
    keyword: "",
    queryType: 1,
    showRoute: false
  };
  const searchResultState = {
    pois: false,
    statistics: false,
    area: false,
    suggests: false,
    prompt: false,
    lineData: false
  };
  const searchViewState = {
    markers: [],
    target: null,
    content: "",
    current: 1,
    total: 0
  };
  const state = reactive(__spreadValues(__spreadValues(__spreadValues({}, searchLocalState), searchResultState), searchViewState));
  return state;
}
const IconSearch = defineComponent({
  setup() {
    return () => h("svg", {
      class: "tdt-icon",
      attrs: {
        t: "1636975674954",
        viewBox: "0 0 1024 1024",
        version: "1.1",
        xmlns: "http://www.w3.org/2000/svg",
        "p-id": "7028",
        width: "200",
        height: "200"
      }
    }, [
      h("path", {
        attrs: {
          d: "M789.804097 737.772047 742.865042 784.699846 898.765741 940.600545 945.704796 893.672746Z",
          "p-id": "7029"
        }
      }),
      h("path", {
        attrs: {
          d: "M456.92259 82.893942c-209.311143 0-379.582131 170.282245-379.582131 379.582131s170.270988 379.570875 379.582131 379.570875c209.287607 0 379.558595-170.270988 379.558595-379.570875S666.210197 82.893942 456.92259 82.893942zM770.128989 462.477097c0 172.721807-140.508127 313.229934-313.206398 313.229934-172.720783 0-313.229934-140.508127-313.229934-313.229934s140.508127-313.229934 313.229934-313.229934C629.620861 149.247162 770.128989 289.75529 770.128989 462.477097z",
          "p-id": "7030"
        }
      })
    ]);
  }
});
const IconRoute = defineComponent({
  setup() {
    return () => h("svg", {
      class: "tdt-icon",
      attrs: {
        t: "1638934785539",
        viewBox: "0 0 1024 1024",
        version: "1.1",
        xmlns: "http://www.w3.org/2000/svg",
        "p-id": "8230",
        width: "200",
        height: "200"
      }
    }, [
      h("path", {
        attrs: {
          d: "M301.952 387.669333l144.981333 54.357334c56.234667 21.077333 113.578667 80.597333 132.565334 137.557333l15.658666 46.933333a42.666667 42.666667 0 1 1-80.981333 26.965334l-15.616-46.933334c-10.88-32.512-49.493333-72.533333-81.578667-84.608L155.733333 423.936c-38.016-14.250667-36.522667-68.565333 2.261334-80.64l682.666666-213.333333a42.666667 42.666667 0 0 1 53.418667 53.418666l-213.333333 682.666667a42.666667 42.666667 0 0 1-81.408-25.429333l189.013333-604.928-486.4 151.978666z",
          "p-id": "8231"
        }
      })
    ]);
  }
});
const IconClose = defineComponent({
  setup() {
    return () => h("svg", {
      class: "tdt-icon",
      attrs: {
        t: "1636975957032",
        viewBox: "0 0 1024 1024",
        version: "1.1",
        xmlns: "http://www.w3.org/2000/svg",
        "p-id": "7161",
        width: "200",
        height: "200"
      }
    }, [
      h("path", {
        attrs: {
          d: "M562.281173 510.800685l294.996664-293.466821c13.94971-13.878079 14.020318-36.367279 0.14224-50.316989-13.913894-13.984503-36.367279-14.020318-50.316989-0.14224L512.034792 460.377272 219.528855 166.982082c-13.842263-13.878079-36.367279-13.94971-50.316989-0.071631-13.913894 13.878079-13.948687 36.403095-0.071631 50.352805L461.576587 510.587837 166.721139 803.876604c-13.94971 13.878079-14.020318 36.367279-0.14224 50.316989 6.939039 6.974855 16.084327 10.497075 25.229614 10.497075 9.073656 0 18.148335-3.451612 25.087375-10.354835l294.926056-293.360398 295.17472 296.064996c6.939039 6.974855 16.048511 10.462283 25.193799 10.462283 9.109472 0 18.184151-3.487428 25.12319-10.390651 13.913894-13.878079 13.94971-36.367279 0.071631-50.316989L562.281173 510.800685z",
          "p-id": "7162"
        }
      })
    ]);
  }
});
var searchBox = "";
const SearchBox = defineComponent({
  props: {
    value: { type: String, default: "" },
    modelValue: { type: String, default: "" },
    placeholder: { type: String, default: "\u8F93\u5165\u5173\u952E\u5B57\u641C\u7D22" },
    searchBtn: { type: Boolean, default: true },
    routeBtn: { type: Boolean, default: true }
  },
  emits: {
    input: (e) => true,
    "update:modelValue": (e) => true,
    search: (e) => true
  },
  setup(props, { emit, slots }) {
    let isComposition = false;
    const keyword = computed({
      get() {
        return isVue2 ? props.value : props.modelValue;
      },
      set(val) {
        isVue2 ? emit("input", val) : emit("update:modelValue", val);
      }
    });
    return () => h("div", {
      class: "tdt-search-box"
    }, [
      h("input", {
        class: "tdt-search-box__input",
        attrs: {
          type: "text",
          placeholder: props.placeholder
        },
        domProps: {
          value: keyword.value
        },
        on: {
          compositionstart: () => isComposition = true,
          compositionend: () => isComposition = false,
          input: (e) => setTimeout(() => !isComposition && (keyword.value = e.target.value)),
          keyup: (e) => e.code === "Enter" && emit("search", keyword.value)
        }
      }),
      h("i", {
        class: "tdt-search-box__close",
        style: { display: props.value || props.modelValue ? "block" : "none" },
        on: {
          click: () => keyword.value = ""
        }
      }, [h(IconClose)]),
      slot(slots.default)
    ]);
  }
});
var searchSuggests = "";
const SearchSuggests = defineComponent({
  props: {
    suggests: { type: Array, default: () => [] }
  },
  emits: {
    "suggest-click": (e) => true
  },
  setup(props, { emit }) {
    return () => h("div", {
      class: "tdt-search-suggests",
      style: { display: props.suggests.length ? "block" : "none" }
    }, props.suggests.map((item) => {
      return h("div", {
        class: "search-suggests-item",
        on: {
          click: () => emit("suggest-click", item)
        }
      }, [
        h("span", { class: "search-suggests-item__name" }, item.name),
        h("span", { class: "search-suggests-item__address" }, item.address)
      ]);
    }));
  }
});
var searchPage = "";
const SearchPage = defineComponent({
  props: {
    current: { type: Number, default: 1 },
    size: { type: Number, default: 10 },
    total: { type: Number, default: 0 }
  },
  emits: {
    "update:current": (e) => true
  },
  setup(props, { emit }) {
    const pageCount = computed(() => {
      return Math.ceil(Number(props.total) / Number(props.size));
    });
    const pageCurrent = computed({
      get() {
        return props.current;
      },
      set(val) {
        let current = val;
        if (val < 1)
          current = 1;
        if (val > pageCount.value)
          current = pageCount.value;
        emit("update:current", current);
      }
    });
    return () => h("div", {
      class: "tdt-search-page"
    }, [
      h("span", {
        class: "tdt-search-page__btn first-page",
        on: {
          click: () => pageCurrent.value = 1
        }
      }, "\xAB"),
      h("span", {
        class: "tdt-search-page__btn prev-page",
        on: {
          click: () => pageCurrent.value--
        }
      }, "\u2039"),
      h("span", null, pageCurrent.value),
      h("span", null, " / "),
      h("span", null, pageCount.value),
      h("span", {
        class: "tdt-search-page__btn next-page",
        on: {
          click: () => pageCurrent.value++
        }
      }, "\u203A"),
      h("span", {
        class: "tdt-search-page__btn last-page",
        on: {
          click: () => pageCurrent.value = pageCount.value
        }
      }, "\xBB")
    ]);
  }
});
var searchPois = "";
const SearchPois = defineComponent({
  props: {
    pois: { type: Array, default: () => [] },
    page: { type: Object }
  },
  emits: {
    "poi-click": (e) => true,
    "update:page": (e) => true
  },
  setup(props, { emit }) {
    return () => {
      var _a, _b, _c;
      return h("div", {
        class: "tdt-search-pois",
        style: { display: props.pois.length ? "block" : "none" }
      }, [
        ...props.pois.map((item) => {
          return h("div", {
            class: "search-pois-item",
            on: {
              click: () => emit("poi-click", item)
            }
          }, [
            h("strong", { class: "search-pois-item__name" }, item.name),
            h("br"),
            h("span", { class: "search-pois-item__address" }, item.address)
          ]);
        }),
        h(SearchPage, {
          props: {
            current: (_a = props.page) == null ? void 0 : _a.current,
            size: (_b = props.page) == null ? void 0 : _b.size,
            total: (_c = props.page) == null ? void 0 : _c.total
          },
          on: {
            "update:current": (current) => {
              emit("update:page", __spreadProps(__spreadValues({}, props.page || {}), { current }));
            }
          }
        })
      ]);
    };
  }
});
const SearchMapView = defineComponent({
  props: {
    pois: { type: Array, default: () => [] },
    target: { type: Array, default: () => null },
    content: { type: String, default: "" }
  },
  emits: {
    "poi-click": (e) => true,
    "update-target": (e) => true
  },
  setup(props, { emit }) {
    const markers = computed(() => {
      return props.pois.map((poi) => {
        return {
          position: poi.lonlat.split(" ").map(Number),
          extData: poi
        };
      });
    });
    onBeforeMount(async () => {
      const tdtMap = await useMapRoot();
      watch(markers, () => {
        tdtMap == null ? void 0 : tdtMap.setViewport(toLngLats(markers.value.map((e) => e.position)));
      });
    });
    return () => h("div", null, [
      ...markers.value.map((item) => {
        return h(TdtMarker, {
          props: __spreadValues({}, item),
          on: {
            click: () => emit("poi-click", item.extData)
          }
        });
      }),
      h(TdtInfowindow, {
        props: {
          target: props.target,
          content: props.content,
          offset: [0, -30],
          minWidth: 150
        },
        on: {
          "update:target": (e) => emit("update-target", e)
        }
      })
    ]);
  }
});
async function useInit$1(state) {
  const { onSearchComplete, onDrivingComplete, onTransitComplete } = useMethods(state);
  state.tdtMap = await useMapRoot();
  state.localSearch = new T.LocalSearch(state.tdtMap, {
    pageCapacity: 10,
    onSearchComplete
  });
  state.drivingRoute = new T.DrivingRoute(state.tdtMap, {
    policy: state.drivingPolicy,
    onSearchComplete: onDrivingComplete
  });
  state.transitRoute = new T.TransitRoute(state.tdtMap, {
    policy: state.transitPolicy,
    onSearchComplete: onTransitComplete
  });
}
function useWatch(state) {
  function resetRoutes() {
    state.drivingLines = [];
    state.walkLines = [];
    state.busLines = [];
    state.busMarkers = [];
    state.metroMarkers = [];
  }
  function resetPlans() {
    state.transitPlans = [];
    state.transitPlanIndex = 0;
    state.drivingPlans = [];
    state.drivingPlanIndex = 0;
  }
  watch(() => {
    const { startMarker, endMarker, routeType, drivingPolicy, transitPolicy } = state;
    return { startMarker, endMarker, routeType, drivingPolicy, transitPolicy };
  }, ({ startMarker, endMarker, routeType, drivingPolicy, transitPolicy }) => {
    var _a, _b, _c, _d, _e, _f;
    resetPlans();
    resetRoutes();
    if (startMarker.length && endMarker.length) {
      switch (routeType) {
        case 0:
          (_a = state.drivingRoute) == null ? void 0 : _a.setPolicy(drivingPolicy);
          (_b = state.drivingRoute) == null ? void 0 : _b.search(toLngLat(startMarker), toLngLat(endMarker));
          break;
        case 1:
          (_c = state.transitRoute) == null ? void 0 : _c.setPolicy(transitPolicy);
          (_d = state.transitRoute) == null ? void 0 : _d.search(toLngLat(startMarker), toLngLat(endMarker));
          break;
        case 2:
          (_e = state.drivingRoute) == null ? void 0 : _e.setPolicy(4);
          (_f = state.drivingRoute) == null ? void 0 : _f.search(toLngLat(startMarker), toLngLat(endMarker));
          break;
      }
    }
  }, { immediate: true });
  watch(() => ({ drivingPlans: state.drivingPlans, drivingPlanIndex: state.drivingPlanIndex }), ({ drivingPlans, drivingPlanIndex }) => {
    var _a;
    resetRoutes();
    const { routelatlon } = drivingPlans[drivingPlanIndex] || {};
    if (!routelatlon)
      return;
    const lines = routelatlon.split(";").filter((e) => e).map((e) => e.split(",").map(Number));
    state.drivingLines.push(lines);
    (_a = state.tdtMap) == null ? void 0 : _a.setViewport(toLngLats(state.drivingLines.flat()));
  }, { immediate: true });
  watch(() => ({ transitPlans: state.transitPlans, transitPlanIndex: state.transitPlanIndex }), ({ transitPlans, transitPlanIndex }) => {
    var _a;
    resetRoutes();
    const { segments } = transitPlans[transitPlanIndex] || {};
    if (!segments)
      return;
    segments.forEach((segment) => {
      const lines = segment.segmentLine.map((line) => line.linePoint.split(";").filter((e) => e).map((e) => e.split(",").map(Number)));
      const markers = [segment.stationStart, segment.stationEnd].map((station) => station.lonlat.split(",").map(Number));
      switch (segment.segmentType) {
        case 1:
        case 4:
          state.walkLines.push(...lines);
          break;
        case 2:
          state.busMarkers.push(...markers);
          state.busLines.push(...lines);
          break;
        case 3:
          state.metroMarkers.push(...markers);
          state.busLines.push(...lines);
          break;
      }
    });
    (_a = state.tdtMap) == null ? void 0 : _a.setViewport(toLngLats([...state.busLines, ...state.walkLines].flat()));
  }, { immediate: true });
}
function useMethods(state) {
  function onSearchComplete(result) {
    state.pois = result.pois;
  }
  function onDrivingComplete(result) {
    state.drivingPlans = [];
    state.drivingPlans = [result.results];
  }
  function onTransitComplete(result) {
    state.transitPlans = [];
    state.transitPlans = result.results.lines;
  }
  function onSearch(queryType, keyword, poiType) {
    var _a;
    state.pois = [];
    state.poiType = poiType;
    state[`${poiType}Keyword`] = keyword;
    if (keyword) {
      (_a = state.localSearch) == null ? void 0 : _a.search(keyword, queryType);
    }
  }
  function onPoiClick(poi) {
    state[`${state.poiType}Keyword`] = poi.name;
    state[`${state.poiType}Marker`] = poi.lonlat.split(" ").map(Number);
    state.pois = [];
  }
  function onPageChange(page) {
    var _a;
    state.current = page.current || 1;
    (_a = state.localSearch) == null ? void 0 : _a.gotoPage(state.current);
  }
  return {
    onSearchComplete,
    onDrivingComplete,
    onTransitComplete,
    onSearch,
    onPoiClick,
    onPageChange
  };
}
function useState() {
  const searchState = {
    tdtMap: null,
    localSearch: null,
    startKeyword: "",
    startMarker: [],
    endKeyword: "",
    endMarker: [],
    routeType: 0,
    poiType: "start",
    pois: [],
    current: 1,
    total: 0
  };
  const drivingState = {
    drivingRoute: null,
    drivingLines: [],
    drivingPolicy: 0,
    drivingPlans: [],
    drivingPlanIndex: 0
  };
  const transitState = {
    transitRoute: null,
    transitPlans: [],
    transitPlanIndex: 0,
    transitPolicy: 1,
    walkLines: [],
    busLines: [],
    busMarkers: [],
    metroMarkers: []
  };
  const injectState = inject("routeState");
  const state = injectState || reactive(__spreadValues(__spreadValues(__spreadValues({}, searchState), drivingState), transitState));
  return state;
}
const RouteMapView = defineComponent({
  setup() {
    const state = useState();
    return () => h("span", null, [
      state.startMarker.length ? h(TdtMarker, {
        props: {
          position: state.startMarker,
          icon: {
            iconUrl: "http://lbs.tianditu.gov.cn/images/bus/start.png",
            iconSize: [44, 34],
            iconAnchor: [12, 31]
          }
        }
      }) : "",
      state.endMarker.length ? h(TdtMarker, {
        props: {
          position: state.endMarker,
          icon: {
            iconUrl: "http://lbs.tianditu.gov.cn/images/bus/end.png",
            iconSize: [44, 34],
            iconAnchor: [12, 31]
          }
        }
      }) : "",
      state.drivingLines.map((path) => h(TdtPolyline, {
        props: {
          path,
          color: "#2C64A7",
          lineStyle: "solid",
          weight: 5,
          opacity: 1
        }
      })),
      state.walkLines.map((path) => h(TdtPolyline, {
        props: {
          path,
          color: "#2E9531",
          lineStyle: "dashed",
          weight: 4,
          opacity: 1
        }
      })),
      state.busLines.map((path) => h(TdtPolyline, {
        props: {
          path,
          color: "#2C64A7",
          lineStyle: "solid",
          weight: 4,
          opacity: 1
        }
      })),
      state.busMarkers.map((position) => h(TdtMarker, {
        props: {
          position,
          icon: {
            iconUrl: "http://lbs.tianditu.gov.cn/images/bus/map_bus.png",
            iconSize: [23, 23],
            iconAnchor: [12, 12]
          }
        }
      })),
      state.metroMarkers.map((position) => h(TdtMarker, {
        props: {
          position,
          icon: {
            iconUrl: "http://lbs.tianditu.gov.cn/images/bus/map_metro.png",
            iconSize: [23, 23],
            iconAnchor: [12, 12]
          }
        }
      }))
    ]);
  }
});
var routePlans = "";
const RoutePlans = defineComponent({
  setup() {
    const state = useState();
    return () => h("div", {
      class: "route-plans"
    }, [
      state.drivingPlans.length ? h("div", null, state.drivingPlans.map((plan, planIndex) => h("details", {
        on: {
          click: () => {
            state.drivingPlanIndex = planIndex;
          }
        }
      }, [
        h("summary", null, `\u65B9\u6848${planIndex + 1}: ${plan.duration} \u79D2 | ${plan.distance} \u516C\u91CC`),
        ...plan.routes.item.map((item, itemIndex) => {
          return h("div", null, `${itemIndex + 1}.${item.strguide}`);
        })
      ]))) : "",
      state.drivingPlans.length ? h("div", null, state.transitPlans.map((plan, planIndex) => h("details", {
        on: {
          click: () => {
            state.transitPlanIndex = planIndex;
          }
        },
        style: { backgroundColor: "#fff" }
      }, [
        h("summary", null, `\u65B9\u6848${planIndex + 1}: ${plan.lineName}`),
        plan.segments.map((segment, segmentIndex) => {
          const segmentLine = segment.segmentLine[0];
          const stationCount = segmentLine.segmentStationCount ? "\uFF0C\u7ECF\u8FC7" + segmentLine.segmentStationCount + "\u7AD9" : "";
          switch (segment.segmentType) {
            case 1:
              return "\u6B65\u884C\u7EA6" + segmentLine.segmentDistance + "\u7C73\uFF0C\u5230\u8FBE" + segment.stationEnd.name;
            case 2:
            case 3:
              return "\u4E58\u5750" + segmentLine.direction + stationCount + "\uFF0C\u5230\u8FBE" + segment.stationEnd.name;
            case 4:
              return "\u7AD9\u5185\u6362\u4E58";
            default:
              return "";
          }
        }).join("\uFF0C") + "\u7EC8\u70B9"
      ]))) : ""
    ]);
  }
});
var routePolicies = "";
const RoutePolicies = defineComponent({
  setup() {
    const state = useState();
    const drivingPolicies = { 0: "\u6700\u5C11\u65F6\u95F4", 1: "\u6700\u77ED\u8DDD\u79BB", 2: "\u907F\u5F00\u9AD8\u901F" };
    const transitPolicies = { 1: "\u6700\u5C11\u65F6\u95F4", 2: "\u6700\u5C11\u6362\u4E58", 4: "\u6700\u5C11\u6B65\u884C", 8: "\u4E0D\u4E58\u5730\u94C1" };
    return () => h("div", {
      class: "route-policies"
    }, [
      ...state.routeType === 0 ? Object.entries(drivingPolicies).map(([key, value]) => h("div", {
        class: "route-policies-item" + (state.drivingPolicy == Number(key) ? " active" : ""),
        on: {
          click: () => state.drivingPolicy = Number(key)
        }
      }, value)) : [],
      ...state.routeType === 1 ? Object.entries(transitPolicies).map(([key, value]) => h("div", {
        class: "route-policies-item" + (state.transitPolicy == Number(key) ? " active" : ""),
        on: {
          click: () => state.transitPolicy = Number(key)
        }
      }, value)) : []
    ]);
  }
});
const RouteSearch = defineComponent({
  setup() {
    const state = useState();
    const { onSearch, onPoiClick, onPageChange } = useMethods(state);
    return () => h("div", { class: "route-search" }, [
      h(SearchBox, {
        props: {
          value: state.startKeyword,
          modelValue: state.startKeyword,
          placeholder: "\u8BF7\u8F93\u5165\u8D77\u70B9"
        },
        on: {
          focus: () => state.poiType = "start",
          input: (val) => onSearch(1, val, "start"),
          "update:modelValue": (val) => onSearch(1, val, "start")
        }
      }),
      h(SearchBox, {
        props: {
          value: state.endKeyword,
          modelValue: state.endKeyword,
          placeholder: "\u8BF7\u8F93\u5165\u7EC8\u70B9"
        },
        on: {
          focus: () => state.poiType = "end",
          input: (val) => onSearch(1, val, "end"),
          "update:modelValue": (val) => onSearch(1, val, "end")
        }
      }),
      h(SearchPois, {
        props: {
          pois: state.pois || [],
          page: {
            current: state.current,
            size: 10,
            total: state.total
          }
        },
        on: {
          "poi-click": onPoiClick,
          "update:page": onPageChange
        }
      })
    ]);
  }
});
var routeTypes = "";
const RouteTypes = defineComponent({
  setup() {
    const state = useState();
    const routeTypes2 = { 0: "\u9A7E\u8F66", 1: "\u516C\u4EA4", 2: "\u6B65\u884C" };
    return () => h("div", {
      class: "route-types"
    }, [
      ...Object.entries(routeTypes2).map(([key, value]) => h("div", {
        class: "route-types-item" + (state.routeType == Number(key) ? " active" : ""),
        on: {
          click: () => state.routeType = Number(key)
        }
      }, value))
    ]);
  }
});
var tdtIcon = "";
var tdtRoute = "";
const TdtRoute = defineComponent({
  name: "TdtRoute",
  setup() {
    const state = useState();
    provide("routeState", state);
    onBeforeMount(async () => {
      await useInit$1(state);
      useWatch(state);
    });
    return () => h("div", {
      class: "tdt-route",
      on: __spreadValues({}, fixMapPropagation(state.tdtMap))
    }, [h(RouteTypes), h(RouteSearch), h(RoutePolicies), h(RoutePlans), h(RouteMapView)]);
  }
});
var tdtSearch = "";
const TdtSearch = defineComponent({
  name: "TdtSearch",
  props: {
    placeholder: { type: String, default: "\u8F93\u5165\u5173\u952E\u5B57\u641C\u7D22" },
    searchBtn: { type: Boolean, default: true },
    routeBtn: { type: Boolean, default: true }
  },
  emits: {
    "poi-click": (poi) => true,
    "suggest-click": (suggest) => true,
    "search-complete": (result) => true
  },
  setup(props, { emit }) {
    const state = useState$1();
    const { onSearchComplete, onPoiClick, onSuggestClick, onSearch, onPageChange } = useMethods$1(state, emit);
    onBeforeMount(async () => {
      state.tdtMap = await useMapRoot();
      state.localSearch = new T.LocalSearch(state.tdtMap, {
        pageCapacity: 10,
        onSearchComplete
      });
    });
    return () => h("div", {
      class: "tdt-search",
      on: __spreadValues({}, fixMapPropagation(state.tdtMap))
    }, state.showRoute ? [
      h(TdtRoute),
      h("i", {
        class: "tdt-search-route__close",
        on: {
          click: () => state.showRoute = false
        }
      }, [h(IconClose)])
    ] : [
      h(SearchBox, {
        props: {
          value: state.keyword,
          modelValue: state.keyword,
          placeholder: props.placeholder
        },
        on: {
          input: (val) => {
            state.keyword = val;
            onSearch(4, val);
          },
          "update:modelValue": (val) => {
            state.keyword = val;
            onSearch(4, val);
          },
          search: (val) => onSearch(1, val)
        },
        scopedSlots: {
          default: () => [
            props.searchBtn && h("button", {
              class: "tdt-search-box__btn",
              on: {
                click: () => onSearch(1)
              }
            }, [h(IconSearch)]),
            props.routeBtn && h("button", {
              class: "tdt-search-box__btn",
              on: {
                click: () => state.showRoute = true
              }
            }, [h(IconRoute)])
          ]
        }
      }),
      h(SearchSuggests, {
        props: {
          suggests: state.suggests || []
        },
        on: {
          "suggest-click": onSuggestClick
        }
      }),
      h(SearchPois, {
        props: {
          pois: state.pois || [],
          page: {
            current: state.current,
            size: 10,
            total: state.total
          }
        },
        on: {
          "poi-click": onPoiClick,
          "update:page": onPageChange
        }
      }),
      h(SearchMapView, {
        props: {
          pois: state.pois || [],
          target: state.target,
          content: state.content
        },
        on: {
          "poi-click": onPoiClick,
          "update:target": (e) => state.target = e
        }
      })
    ]);
  }
});
const NATIVE_PROPS = {
  interval: { type: Number, default: 1e3 },
  speed: { type: Number, default: 0 },
  dynamicLine: { type: Boolean, default: false },
  Datas: { type: Array, default: () => [] },
  carstyle: {
    type: Object
  },
  polylinestyle: {
    type: Object
  }
};
const EXTRA_PROPS = {};
const NATIVE_EVENTS = {};
const EXTRA_EVENTS = {
  init: (e) => e instanceof T.CarTrack,
  passOneNode: (lnglat, index, length) => true
};
const PROPS = __spreadValues(__spreadValues({}, NATIVE_PROPS), EXTRA_PROPS);
const EVENTS = __spreadValues(__spreadValues({}, NATIVE_EVENTS), EXTRA_EVENTS);
function useInit(props, emit, map) {
  const { interval, speed, dynamicLine, Datas, carstyle, polylinestyle } = props;
  const instance = new T.CarTrack(map, {
    interval,
    speed,
    dynamicLine,
    Datas: toLngLats(Datas),
    carstyle,
    polylinestyle,
    passOneNode: (lnglat, index, length) => {
      emit("passOneNode", [lnglat.lng, lnglat.lat], index, length);
    }
  });
  return instance;
}
const TdtCarTrack = defineComponent({
  name: "TdtCarTrack",
  props: PROPS,
  emits: EVENTS,
  setup(props, { emit, expose }) {
    onBeforeMount(async () => {
      var _a;
      onUnmounted(() => tdtComponent == null ? void 0 : tdtComponent.clear());
      expose == null ? void 0 : expose({ start, pause, stop, clear });
      if (isVue2) {
        const vm = (_a = getCurrentInstance()) == null ? void 0 : _a.proxy;
        vm.star = start;
        vm.paus = pause;
        vm.sto = stop;
      }
      const tdtMap = await useMapRoot();
      let tdtComponent = null;
      watch(() => props.Datas, (val) => {
        tdtComponent == null ? void 0 : tdtComponent.clear();
        tdtComponent = null;
        if (!val.length)
          return;
        tdtComponent = useInit(props, emit, tdtMap);
        emit("init", tdtComponent);
      }, { immediate: true });
      function start() {
        tdtComponent == null ? void 0 : tdtComponent.start();
      }
      function pause() {
        tdtComponent == null ? void 0 : tdtComponent.pause();
      }
      function stop() {
        tdtComponent == null ? void 0 : tdtComponent.stop();
      }
      function clear() {
        tdtComponent == null ? void 0 : tdtComponent.clear();
      }
    });
    return () => {
    };
  }
});
var components = /* @__PURE__ */ Object.freeze({
  __proto__: null,
  [Symbol.toStringTag]: "Module",
  TdtMap,
  TdtControl,
  TdtMousetool,
  TdtMarker,
  TdtLabel,
  TdtPolyline,
  TdtPolygon,
  TdtRectangle,
  TdtCircle,
  TdtInfowindow,
  TdtCloudMarkerCollection,
  TdtMarkerClusterer,
  TdtTilelayer,
  TdtTilelayerTdt,
  TdtTilelayerWms,
  TdtGridlineLayer,
  TdtSearch,
  TdtRoute,
  TdtCarTrack
});
var install = {
  install: (app, config) => {
    useApiLoader(config);
    Object.values(components).forEach((component) => {
      app.component(component.name, component);
    });
  }
};
export { TdtCarTrack, TdtCircle, TdtCloudMarkerCollection, TdtControl, TdtGridlineLayer, TdtInfowindow, TdtLabel, TdtMap, TdtMarker, TdtMarkerClusterer, TdtMousetool, TdtPolygon, TdtPolyline, TdtRectangle, TdtRoute, TdtSearch, TdtTilelayer, TdtTilelayerTdt, TdtTilelayerWms, install as default, objectFilter, toBounds, toIcon, toLngLat, toLngLats, toMarker, toPoint, useApiLoader };
